/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateFullCveRecordRequestContainersCnaAffectedInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateFullCveRecordRequestContainersCnaAffectedInner{}

// CreateFullCveRecordRequestContainersCnaAffectedInner struct for CreateFullCveRecordRequestContainersCnaAffectedInner
type CreateFullCveRecordRequestContainersCnaAffectedInner struct {
	Vendor *string `json:"vendor,omitempty"`
	Product *string `json:"product,omitempty"`
	Versions []GetCveRecordResponseContainersCnaAffectedVersionsInner `json:"versions,omitempty"`
}

// NewCreateFullCveRecordRequestContainersCnaAffectedInner instantiates a new CreateFullCveRecordRequestContainersCnaAffectedInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateFullCveRecordRequestContainersCnaAffectedInner() *CreateFullCveRecordRequestContainersCnaAffectedInner {
	this := CreateFullCveRecordRequestContainersCnaAffectedInner{}
	return &this
}

// NewCreateFullCveRecordRequestContainersCnaAffectedInnerWithDefaults instantiates a new CreateFullCveRecordRequestContainersCnaAffectedInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateFullCveRecordRequestContainersCnaAffectedInnerWithDefaults() *CreateFullCveRecordRequestContainersCnaAffectedInner {
	this := CreateFullCveRecordRequestContainersCnaAffectedInner{}
	return &this
}

// GetVendor returns the Vendor field value if set, zero value otherwise.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) GetVendor() string {
	if o == nil || IsNil(o.Vendor) {
		var ret string
		return ret
	}
	return *o.Vendor
}

// GetVendorOk returns a tuple with the Vendor field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) GetVendorOk() (*string, bool) {
	if o == nil || IsNil(o.Vendor) {
		return nil, false
	}
	return o.Vendor, true
}

// HasVendor returns a boolean if a field has been set.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) HasVendor() bool {
	if o != nil && !IsNil(o.Vendor) {
		return true
	}

	return false
}

// SetVendor gets a reference to the given string and assigns it to the Vendor field.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) SetVendor(v string) {
	o.Vendor = &v
}

// GetProduct returns the Product field value if set, zero value otherwise.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) GetProduct() string {
	if o == nil || IsNil(o.Product) {
		var ret string
		return ret
	}
	return *o.Product
}

// GetProductOk returns a tuple with the Product field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) GetProductOk() (*string, bool) {
	if o == nil || IsNil(o.Product) {
		return nil, false
	}
	return o.Product, true
}

// HasProduct returns a boolean if a field has been set.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) HasProduct() bool {
	if o != nil && !IsNil(o.Product) {
		return true
	}

	return false
}

// SetProduct gets a reference to the given string and assigns it to the Product field.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) SetProduct(v string) {
	o.Product = &v
}

// GetVersions returns the Versions field value if set, zero value otherwise.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) GetVersions() []GetCveRecordResponseContainersCnaAffectedVersionsInner {
	if o == nil || IsNil(o.Versions) {
		var ret []GetCveRecordResponseContainersCnaAffectedVersionsInner
		return ret
	}
	return o.Versions
}

// GetVersionsOk returns a tuple with the Versions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) GetVersionsOk() ([]GetCveRecordResponseContainersCnaAffectedVersionsInner, bool) {
	if o == nil || IsNil(o.Versions) {
		return nil, false
	}
	return o.Versions, true
}

// HasVersions returns a boolean if a field has been set.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) HasVersions() bool {
	if o != nil && !IsNil(o.Versions) {
		return true
	}

	return false
}

// SetVersions gets a reference to the given []GetCveRecordResponseContainersCnaAffectedVersionsInner and assigns it to the Versions field.
func (o *CreateFullCveRecordRequestContainersCnaAffectedInner) SetVersions(v []GetCveRecordResponseContainersCnaAffectedVersionsInner) {
	o.Versions = v
}

func (o CreateFullCveRecordRequestContainersCnaAffectedInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateFullCveRecordRequestContainersCnaAffectedInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Vendor) {
		toSerialize["vendor"] = o.Vendor
	}
	if !IsNil(o.Product) {
		toSerialize["product"] = o.Product
	}
	if !IsNil(o.Versions) {
		toSerialize["versions"] = o.Versions
	}
	return toSerialize, nil
}

type NullableCreateFullCveRecordRequestContainersCnaAffectedInner struct {
	value *CreateFullCveRecordRequestContainersCnaAffectedInner
	isSet bool
}

func (v NullableCreateFullCveRecordRequestContainersCnaAffectedInner) Get() *CreateFullCveRecordRequestContainersCnaAffectedInner {
	return v.value
}

func (v *NullableCreateFullCveRecordRequestContainersCnaAffectedInner) Set(val *CreateFullCveRecordRequestContainersCnaAffectedInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateFullCveRecordRequestContainersCnaAffectedInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateFullCveRecordRequestContainersCnaAffectedInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateFullCveRecordRequestContainersCnaAffectedInner(val *CreateFullCveRecordRequestContainersCnaAffectedInner) *NullableCreateFullCveRecordRequestContainersCnaAffectedInner {
	return &NullableCreateFullCveRecordRequestContainersCnaAffectedInner{value: val, isSet: true}
}

func (v NullableCreateFullCveRecordRequestContainersCnaAffectedInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateFullCveRecordRequestContainersCnaAffectedInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


